TOPCOLOR	equ	$08
TextClrTab
	.byte $08
	.byte $0A
	.byte $0C
	.byte $0E
	.byte $0E
	.byte $0C
	.byte $0A
	.byte TOPCOLOR

	;Very important in order for some branches below not to cross page boundaries
	;Could probably have been done prettier though
	align 128

AlignedKernel
	;if intro, then black
	;otherwise continue
	lda measure
	cmp #INTROLENGTH
	bcs NormalKernel

	ldx #LINES-4
BlackKernelLoop
	sta WSYNC
	dex
	bne BlackKernelLoop
	jmp Overscan

NormalKernel
	ldx #0
	lda #STARTOP
	sta starend
	jmp StarKernel
StarKernelRetTop

#if TARTW == 1
	lda #$00 | HEADNSZ
#else
	lda #$10 | HEADNSZ
#endif
	sta NUSIZ1
	lda #HEADBK
	sta COLUP1

	lda headx
	ldx #1
	jsr PositionObject2

	SLEEP 20
	sta HMCLR

	ldx #TOP
Kernel
	sta WSYNC
	sta HMOVE
	dex
#if KSIZE == 2
	sta WSYNC
	sta HMOVE
#endif
	bne Kernel

	lda tartup
	bne TopTartUp

	sta WSYNC
	sta HMOVE
#if KSIZE == 2
	sta WSYNC
	sta HMOVE
#endif

TopTartUp
#if KSIZE == 2
	ldx #KSIZE
#endif
TopTartUp_Loop
	lda #0
	sta HMM0
	sta GRP1

	sta WSYNC
	sta HMOVE

	lda #$FF
	sta PF0
	sta PF1
	lda #TARTBRD
	sta COLUBK
	ldy animfrm
	lda TailHM,y
	sta HMM0
	ldy rborder
	lda #0
	sta PF0
	SLEEP 6
	lda #2
	sta ENAM1
	lda #DBLUE
	sta COLUBK
	sty GRP1

#if KSIZE == 2
	dex
	bne TopTartUp_Loop
#endif

	lda tartup
	beq TopTartDown

#if KSIZE == 2
	ldx #KSIZE
#endif
TopTartUp_Loop2
	lda #0
	sta HMM0

	sta WSYNC
	sta HMOVE

	lda #$FF
	sta PF0
	sta PF1
	lda #PINK
	sta COLUBK
	lda #2
	sta ENAM1
	ldy animfrm
	lda TailHM,y
	sta HMM0
	lda rborder
	sta GRP1
	lda #0
	sta PF0
	SLEEP 3
	lda #DBLUE
	sta COLUBK

#if KSIZE == 2
	dex
	bne TopTartUp_Loop2
#endif

TopTartDown
	ldy #TAILH
TailKernel
	lda rainpar
	bne OddTailKernel
BRANCH	equ	*

EvenTailKernel

	MAC KERNEL
.C	SET	{1}

	ldx #%11000000

	sta WSYNC
	sta HMOVE

	lda TailColors-.C,Y
	sta COLUPF
	lda TailColors-1+.C,Y
	sta COLUBK
	stx PF0
	lda #%00110011
	sta PF1
	nop
	nop
	ldx #RED
	lda #PINK
	sta COLUBK
	stx COLUPF
	lda #DBLUE
	SLEEP 3
	sta COLUPF
	sta COLUBK
	SLEEP 7

	lda (enamptr),Y
	sta ENAM0
#if DO_2ND_LINE_WSYNC
	sta WSYNC
#else
	lda (cherptr),Y
	sta HMBL
	sta ENABL
#endif
	sta HMOVE

	ldx #%11000000
	lda TailColors-.C,Y
	sta COLUPF
	lda TailColors-1+.C,Y
	sta COLUBK
	stx PF0
	lda #%00110011
	sta PF1
	lda #PINK
	ldx #RED
	SLEEP 2
	sta COLUBK
	stx COLUPF
	lda #DBLUE
	ldx gfx0-1,Y
	sta COLUPF
	sta COLUBK
	stx GRP0
	ldx gfx1-1,Y
	stx GRP1

	ENDM

	KERNEL 1
	dey
	bne EvenTailKernel
	beq EndKernel

OddTailKernel
	echo "OddTailKernel branch from",BRANCH,"to",*

	KERNEL 0
	dey
	bne OddTailKernel

EndKernel
#if KSIZE == 2
	ldx #KSIZE
#endif
BottomTart_Loop
	sta WSYNC
	sta HMOVE

	lda #$FF
	sta PF0
	sta PF1

	lda tartup
	beq BottomTart_TartDown
	lda #TARTBRD
	sta COLUBK
	sta GRP1
	lda #2
	sta NUSIZ0
	sta NUSIZ1
	sta RESP0-1,X
	bne BottomTart_Continue

BottomTart_TartDown
	lda #PINK
	sta COLUBK
	SLEEP 16

BottomTart_Continue
	lda #0
	sta PF0
	nop
	lda #DBLUE
	sta COLUBK

#if KSIZE == 2
	dex
	bne BottomTart_Loop
#endif

	;if tart down, then draw the bottom
	lda tartup
	beq DoBottomTart

DrawPaws
	ldx pawsh
DrawPaws_Loop
	sta WSYNC
	sta HMOVE

	MAC PAWSKERNEL
	txa
	clc
	adc pawsfrm
	tay

	lda #0
	sta ENAM1

	lda BlackBackPaws0-1,Y
	sta GRP0
	lda BackPaws0-1,Y
	sta GRP1
	lda BlackFrontPaws0-1,Y
	sta GRP0
	lda FrontPaws0-1,Y
	sta GRP1
	ENDM

	PAWSKERNEL

#if KSIZE == 2
	sta WSYNC
	sta HMOVE

	PAWSKERNEL
#endif
	dex
	bne DrawPaws_Loop
	beq DoKernel3

DoBottomTart
	ldx #KSIZE
BottomTart_Bottom
	sta WSYNC
	sta HMOVE

	lda #$FF
	sta PF0
	sta PF1

	SLEEP 5
	lda #0
	sta COLUBK
	sta GRP1
	lda #2
	sta NUSIZ0
	sta NUSIZ1
	sta RESP0-1,X

	lda #0
	sta PF0
	SLEEP 5
	lda #DBLUE
	sta COLUBK

	dex
	bne BottomTart_Bottom
	beq DrawPaws

	;done
DoKernel3
	ldx #BOTTOM
Kernel3
	sta WSYNC
	sta HMOVE
	lda #STARNSZ
	sta NUSIZ1
	lda #0
	sta GRP0
	sta GRP1
	lda #DBLUE
	sta COLUBK
	lda #STARCLR
	sta COLUP1
	dex
#if KSIZE == 2
	sta WSYNC
	sta HMOVE
#endif
	bne Kernel3

	;spaghettified to save RAM
	ldx #STARTOP
	lda #NSTARS
	sta starend
	jmp StarKernel
StarKernelRetBot

	;position P0 and P1 for text
	lda #80-28
	ldx #0
	jsr PositionObject2

	lda #3			;three copies, close
	sta NUSIZ0
	sta NUSIZ1
	lda #1
	sta VDELP1
	lda #TEXTCLR
	sta COLUP0
	sta COLUP1

	SLEEP 4
	sta HMCLR

	lda #80-20
	ldx #1
	jsr PositionObject2

	SLEEP 12
	lda #TOPCOLOR
	sta COLUP0
	sta COLUP1
	sta HMCLR

	;draw text
	lda #FONTH-1
	sta temp
TextKernel
	ldy temp
	ldx text0,Y
	stx GRP0

	sta WSYNC
	sta HMOVE

	ldx text1,Y
	stx GRP1
	lax text2,Y
	sta GRP0
	;P0 and P1 visible

	ldx text3,Y
	stx temp+1

	lax text4,Y
	ldx text5,Y
	tay
	lda temp+1

	SLEEP 5

	;should start at cy 42/px 58
	sta GRP1
	sty GRP0
	stx GRP1
	sta GRP0

	ldy temp
	ldx text0,Y
	stx GRP0

	lda TextClrTab,Y
	sta COLUP0
	sta.w COLUP1

	sta HMOVE

	ldx text1,Y
	stx GRP1
	lax text2,Y
	sta GRP0
	;P0 and P1 visible

	ldx text3,Y
	stx temp+1

	lax text4,Y
	ldx text5,Y
	tay
	lda temp+1

	SLEEP 5

	;should start at cy 42/px 58
	sta GRP1
	sty GRP0
	stx GRP1
	sta GRP0

	dec temp
	bpl TextKernel

	;padding
	sta WSYNC
	sta HMOVE
	lda #0
	sta GRP0
	sta GRP1
	sta GRP0
	sta WSYNC
	sta HMOVE
	sta WSYNC
	sta HMOVE
	sta WSYNC
	sta HMOVE

Overscan
	lda #2
	sta VBLANK
#if PAL
	ldx #OVERSCN
OverScanWait
	;we could do useful work here
	sta WSYNC
	dex
	bne OverScanWait
#else
	sta WSYNC
	lda #OVRSC64
	sta TIM64T	

	NTSC_OVERSCAN_PART

OverScanWait
	lda INTIM
	bne OverScanWait
#endif
	jmp MainLoop
